Re: [PATCH] kbuild: pahole-version: avoid errors if executing fails

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On Fri 23 Aug 2024 02:28:28 GMT, Masahiro Yamada wrote:
> Date: Fri, 23 Aug 2024 02:28:28 +0900
> From: Masahiro Yamada <masahiroy@xxxxxxxxxx>
> To: Miguel Ojeda <ojeda@xxxxxxxxxx>
> Cc: Alexei Starovoitov <ast@xxxxxxxxxx>, Daniel Borkmann
>  <daniel@xxxxxxxxxxxxx>, Andrii Nakryiko <andrii@xxxxxxxxxx>, Martin KaFai
>  Lau <martin.lau@xxxxxxxxx>, Eduard Zingerman <eddyz87@xxxxxxxxx>, Song Liu
>  <song@xxxxxxxxxx>, Yonghong Song <yonghong.song@xxxxxxxxx>, John Fastabend
>  <john.fastabend@xxxxxxxxx>, KP Singh <kpsingh@xxxxxxxxxx>, Stanislav
>  Fomichev <sdf@xxxxxxxxxxx>, Hao Luo <haoluo@xxxxxxxxxx>, Jiri Olsa
>  <jolsa@xxxxxxxxxx>, bpf@xxxxxxxxxxxxxxx, Nathan Chancellor
>  <nathan@xxxxxxxxxx>, Nicolas Schier <nicolas@xxxxxxxxx>,
>  linux-kbuild@xxxxxxxxxxxxxxx, linux-kernel@xxxxxxxxxxxxxxx,
>  patches@xxxxxxxxxxxxxxx
> Subject: Re: [PATCH] kbuild: pahole-version: avoid errors if executing fails
> X-Mailing-List: linux-kbuild@xxxxxxxxxxxxxxx
> Message-ID: <CAK7LNARhR=GGZ2Vr-SSog1yjnjh6iT7cCEe4mpYg889GhJnO9g@xxxxxxxxxxxxxx>
> 
> On Sun, Jul 28, 2024 at 9:55 PM Miguel Ojeda <ojeda@xxxxxxxxxx> wrote:
> >
> > Like patch "rust: suppress error messages from
> > CONFIG_{RUSTC,BINDGEN}_VERSION_TEXT" [1], do not assume the file existing
> > and being executable implies executing it will succeed. Instead, bail
> > out if executing it fails for any reason.
> >
> > For instance, `pahole` may be built for another architecture, may be a
> > program we do not expect or may be completely broken:
> >
> >     $ echo 'bad' > bad-pahole
> >     $ chmod u+x bad-pahole
> >     $ make PAHOLE=./bad-pahole defconfig
> >     ...
> >     ./bad-pahole: 1: bad: not found
> >     init/Kconfig:112: syntax error
> >     init/Kconfig:112: invalid statement
> 
> 
> 
> Even with this patch applied, a syntax error can happen.
> 
> $ git log --oneline -1
> dd1c54d77f11 kbuild: pahole-version: avoid errors if executing fails
> $ echo 'echo' > bad-pahole
> $ chmod u+x bad-pahole
> $ make PAHOLE=./bad-pahole defconfig
> *** Default configuration is based on 'x86_64_defconfig'
> init/Kconfig:114: syntax error
> init/Kconfig:114: invalid statement
> make[2]: *** [scripts/kconfig/Makefile:95: defconfig] Error 1
> make[1]: *** [/home/masahiro/workspace/linux-kbuild/Makefile:680:
> defconfig] Error 2
> make: *** [Makefile:224: __sub-make] Error 2
> 

Do we have to catch all possibilities?  Then, what about this:


#!/bin/sh
trap "echo 0; exit 1" EXIT
set -e

output=$("$@" --version 2>/dev/null)

output=$(echo "${output}" |  sed -nE 's/^v([0-9]+)\.([0-9][0-9])$/\1\2/p')
if [ -z "${output}" ]; then
	echo "warning: pahole binary '$1' outputs incompatible version number, pahole will not be used." >&2
	exit 1
fi

echo "${output}"
trap EXIT



Kind regards,
Nicolas

Attachment: signature.asc
Description: PGP signature


[Index of Archives]     [Linux Samsung SoC]     [Linux Rockchip SoC]     [Linux Actions SoC]     [Linux for Synopsys ARC Processors]     [Linux NFS]     [Linux NILFS]     [Linux USB Devel]     [Video for Linux]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]


  Powered by Linux